| Disk ARchive 2.8.1 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::fichier_local Class Reference
Private

filesystem local files More...

`#include <fichier_local.hpp>`

Inherits libdar::fichier_global.

## Public Member Functions
| fichier_local (const std::shared_ptr< user_interaction > &dialog, const std::string &chemin, gf_mode m, U_I permission, bool fail_if_exists, bool erase, bool furtive_mode)
| full featured constructors
| fichier_local (const std::string &chemin, bool furtive_mode=false)
| constructor without user_interaction
| fichier_local (const fichier_local &ref)
| copy constructor
| fichier_local (fichier_local &&ref) noexcept
| move constructor
fichier_local & | operator= (const fichier_local &ref)
| assignment operator
fichier_local & | operator= (fichier_local &&ref) noexcept
| move operator
| ~fichier_local ()
| destructor
virtual void | change_ownership (const std::string &user, const std::string &group) override
| set the ownership of the file
virtual void | change_permission (U_I perm) override
| change the permission of the file
virtual infinint | get_size () const override
| return the size of the file
virtual void | fadvise (advise adv) const override
| set posix_fadvise for the whole file
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip
virtual bool | skip (const infinint &pos) override
| skip at the absolute position
virtual bool | skip_to_eof () override
| skip to the end of file
virtual bool | skip_relative (S_I x) override
| skip relatively to the current position
virtual bool | truncatable (const infinint &pos) const override
| whether the implementation is able to truncate to the given position
virtual infinint | get_position () const override
| get the current read/write position
S_I | give_fd_and_terminate ()
| provide the low level filedescriptor to the call and terminate()
Public Member Functions inherited from libdar::fichier_global
| fichier_global (const std::shared_ptr< user_interaction > &dialog, gf_mode mode)
| constructor
| fichier_global (const fichier_global &ref)=default
| copy constructor
| fichier_global (fichier_global &&ref) noexcept=default
| move constructor
fichier_global & | operator= (const fichier_global &ref)=default
| assignment operator
fichier_global & | operator= (fichier_global &&ref) noexcept=default
| move operator
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor
Public Member Functions inherited from libdar::thread_cancellation
| thread_cancellation ()
| the constructor
| thread_cancellation (const thread_cancellation &ref)=default
| copy constructor
| thread_cancellation (thread_cancellation &&ref) noexcept=default
| move constructor
thread_cancellation & | operator= (const thread_cancellation &ref)=default
| assignment operator
thread_cancellation & | operator= (thread_cancellation &&ref) noexcept=default
| move operator
virtual | ~thread_cancellation () noexcept(false)
| the destructor
void | check_self_cancellation () const
| Checkpoint test : whether the current libdar call must abort or not.
bool | self_is_under_cancellation () const
| get the current thread status
void | block_delayed_cancellation (bool mode)
Public Member Functions inherited from libdar::mem_ui
| mem_ui (const std::shared_ptr< user_interaction > &dialog)
| constructor
| mem_ui (const mem_ui &ref)=default
| the copy constructor
| mem_ui (mem_ui &&ref) noexcept=default
| the move constructor
mem_ui & | operator= (const mem_ui &ref)=default
| assignement operator
mem_ui & | operator= (mem_ui &&ref) noexcept=default
| move operator
virtual | ~mem_ui () noexcept(false)
| destructor

## Protected Member Functions
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data
virtual void | inherited_sync_write () override
| write down any pending data
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions
virtual U_I | fichier_global_inherited_write (const char *a, U_I size) override
| replaces generic_file::inherited_write() method, to allow the return of partial writings
virtual bool | fichier_global_inherited_read (char *a, U_I size, U_I &read, std::string &message) override
| replaces generic_file::inherited_read() method, to allow the return of partial reading
Protected Member Functions inherited from libdar::fichier_global
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const
Protected Member Functions inherited from libdar::mem_ui
user_interaction & | get_ui () const
| get access to the user_interaction object
std::shared_ptr< user_interaction > | get_pointer () const
| get access to the shared_ptr pointing to the user_interaction
void | change_ui (const std::shared_ptr< user_interaction > &new_dialog)
| change the user_interaction object

## Private Member Functions
void | open (const std::string &chemin, gf_mode m, U_I permission, bool fail_if_exists, bool erase, bool furtive_mode)
void | copy_from (const fichier_local &ref)
void | move_from (fichier_local &&ref) noexcept
void | detruit ()
int | advise_to_int (advise arg) const
void | fsync () const
| sync the data to disk
off_t | get_eof_offset () const

## Private Attributes
S_I | filedesc
advise | adv

## Additional Inherited Members
Public Types inherited from libdar::fichier_global
enum | advise { advise_normal , advise_sequential , advise_random , advise_noreuse , advise_willneed , advise_dontneed }
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward }
Static Public Member Functions inherited from libdar::thread_cancellation
static U_I | count ()
| method for debugging/control purposes

## Detailed Description

filesystem local files

Definition at line 55 of file fichier_local.hpp.

## Constructor & Destructor Documentation

## ◆ fichier_local() [1/3]

libdar::fichier_local::fichier_local | ( | const std::string & | chemin,
|  | bool | furtive_mode = false )

constructor without user_interaction

Note
  can only build a read-only object

## ◆ fichier_local() [2/3]

libdar::fichier_local::fichier_local | ( | const fichier_local & | ref | ) |
| inline

copy constructor

Definition at line 74 of file fichier_local.hpp.

## ◆ fichier_local() [3/3]

libdar::fichier_local::fichier_local | ( | fichier_local && | ref | ) |
| inlinenoexcept

move constructor

Definition at line 77 of file fichier_local.hpp.

## ◆ ~fichier_local()

libdar::fichier_local::~fichier_local | ( |  | ) |
| inline

destructor

Definition at line 86 of file fichier_local.hpp.

## Member Function Documentation

## ◆ change_ownership()

virtual void libdar::fichier_local::change_ownership | ( | const std::string & | user,
|  | const std::string & | group )
| overridevirtual

set the ownership of the file

Implements libdar::fichier_global.

## ◆ change_permission()

virtual void libdar::fichier_local::change_permission | ( | U_I | perm | ) |
| overridevirtual

change the permission of the file

Implements libdar::fichier_global.

## ◆ detruit()

void libdar::fichier_local::detruit | ( |  | ) |
| inlineprivate

Definition at line 139 of file fichier_local.hpp.

## ◆ fadvise()

virtual void libdar::fichier_local::fadvise | ( | advise | adv | ) | const
| overridevirtual

set posix_fadvise for the whole file

Implements libdar::fichier_global.

Referenced by inherited_terminate().

## ◆ fichier_global_inherited_read()

virtual bool libdar::fichier_local::fichier_global_inherited_read | ( | char * | a,
|  | U_I | size,
|  | U_I & | read,
|  | std::string & | message )
| overrideprotectedvirtual

replaces generic_file::inherited_read() method, to allow the return of partial reading

a partial reading is signaled by the inherited class by returning false

Parameters

  [in] | a | points to the area where to store read data
  [in] | size | is the available place to store data
  [out] | read | is the total amount of data read so far
  [out] | message | is the request to send to the user upon partial reading

Returns
  true if the reading is full (either read the maximum allowed data or reached end of file) false is returned if a user interaction can let the reading go further the message to display to the user asking him for action. He will also be proposed to abort the current operation.

Implements libdar::fichier_global.

## ◆ fichier_global_inherited_write()

virtual U_I libdar::fichier_local::fichier_global_inherited_write | ( | const char * | a,
|  | U_I | size )
| overrideprotectedvirtual

replaces generic_file::inherited_write() method, to allow the return of partial writings

a partial writing is allowed when no space is available for writing this let global_ficher interact with the user asking whether it can make place or if (s)he wants to abort

Parameters

  [in] | a | points to the start of the area of data to write
  [in] | size | is the size in byte of the data to write

Returns
  the amount of byte wrote. If the returned value is less than size, this is a partial write, and is assumed that free storage space is missing to complete the operation

Implements libdar::fichier_global.

## ◆ fsync()

void libdar::fichier_local::fsync | ( |  | ) | const
| private

sync the data to disk

this is necessary under Linux for better efficiency before calling fadvise(advise_dontneed) else write pending blocks would stay in the cache more time than necessary

Referenced by inherited_sync_write().

## ◆ get_position()

virtual infinint libdar::fichier_local::get_position | ( |  | ) | const
| overridevirtual

get the current read/write position

Implements libdar::generic_file.

## ◆ get_size()

virtual infinint libdar::fichier_local::get_size | ( |  | ) | const
| overridevirtual

return the size of the file

Implements libdar::fichier_global.

## ◆ give_fd_and_terminate()

S_I libdar::fichier_local::give_fd_and_terminate | ( |  | ) |
| inline

provide the low level filedescriptor to the call and terminate()

Note
  this is the caller duty to close() the provided filedescriptor

Definition at line 112 of file fichier_local.hpp.

References libdar::generic_file::terminate().

## ◆ inherited_flush_read()

virtual void libdar::fichier_local::inherited_flush_read | ( |  | ) |
| inlineoverrideprotectedvirtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 119 of file fichier_local.hpp.

## ◆ inherited_read_ahead()

virtual void libdar::fichier_local::inherited_read_ahead | ( | const infinint & | amount | ) |
| inlineoverrideprotectedvirtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

Definition at line 117 of file fichier_local.hpp.

## ◆ inherited_sync_write()

virtual void libdar::fichier_local::inherited_sync_write | ( |  | ) |
| inlineoverrideprotectedvirtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 118 of file fichier_local.hpp.

References fsync().

## ◆ inherited_terminate()

virtual void libdar::fichier_local::inherited_terminate | ( |  | ) |
| inlineoverrideprotectedvirtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

Definition at line 120 of file fichier_local.hpp.

References libdar::fichier_global::advise_dontneed, and fadvise().

## ◆ inherited_truncate()

virtual void libdar::fichier_local::inherited_truncate | ( | const infinint & | pos | ) |
| overrideprotectedvirtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implements libdar::generic_file.

## ◆ operator=() [1/2]

fichier_local & libdar::fichier_local::operator= | ( | const fichier_local & | ref | ) |
| inline

assignment operator

Definition at line 80 of file fichier_local.hpp.

## ◆ operator=() [2/2]

fichier_local & libdar::fichier_local::operator= | ( | fichier_local && | ref | ) |
| inlinenoexcept

move operator

Definition at line 83 of file fichier_local.hpp.

References libdar::fichier_global::operator=().

## ◆ skip()

virtual bool libdar::fichier_local::skip | ( | const infinint & | pos | ) |
| overridevirtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

## ◆ skip_relative()

virtual bool libdar::fichier_local::skip_relative | ( | S_I | x | ) |
| overridevirtual

skip relatively to the current position

Implements libdar::generic_file.

## ◆ skip_to_eof()

virtual bool libdar::fichier_local::skip_to_eof | ( |  | ) |
| overridevirtual

skip to the end of file

Implements libdar::generic_file.

## ◆ skippable()

virtual bool libdar::fichier_local::skippable | ( | skippability | direction,
|  | const infinint & | amount )
| inlineoverridevirtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

Definition at line 102 of file fichier_local.hpp.

## ◆ truncatable()

virtual bool libdar::fichier_local::truncatable | ( | const infinint & | pos | ) | const
| inlineoverridevirtual

whether the implementation is able to truncate to the given position

Implements libdar::generic_file.

Definition at line 106 of file fichier_local.hpp.

## Member Data Documentation

## ◆ adv

advise libdar::fichier_local::adv
| private

Definition at line 128 of file fichier_local.hpp.

## ◆ filedesc

S_I libdar::fichier_local::filedesc
| private

Definition at line 127 of file fichier_local.hpp.

The documentation for this class was generated from the following file:

- fichier_local.hpp